%{

#include <stdio.h>
#include <string.h>

typedef struct {
    char* name;
    char* descr;
    int exits[4]; 
}
  locStruct;

locStruct locList[50];
int nLoc, startLoc;

char tmp_idList[50][10];
char tmp_name[30], tmp_descr[80];
int  tmp_exit[4];

int find(char *id) {
 int i;
 for(i=0;i<nLoc;i++) {
  if(!strcmp(id,tmp_idList[i]))
   return i;
 }
   
 strcpy(tmp_idList[nLoc],id);
 nLoc++;
 return (nLoc-1);
}

%}

%union{
  int whichDirn;
  char *str;
}

%token <whichDirn> tok_DIRN
%token tok_LOCN
%token tok_DESCR
%token tok_START
%token tok_NAME
%token <str> tok_IDENT
%token <str> tok_STRING


%%
program : locnSpecList startSpec 
           
startSpec : tok_START tok_IDENT
           {startLoc = find($2);}

locnSpec : tok_LOCN tok_IDENT nameSpec descrSpec exitList
            {int k = find($2);
             locList[k].name = strdup(tmp_name);
             locList[k].descr = strdup(tmp_descr);
             memcpy(locList[k].exits, 
                    tmp_exit,
                    4*sizeof(int));}

nameSpec : tok_NAME tok_STRING
            {strcpy(tmp_name,$2);}

descrSpec : tok_DESCR tok_STRING
            {strcpy(tmp_descr, $2);}

locnSpecList : locnSpec 
        
locnSpecList : locnSpecList locnSpec 
        
exitList :  {int i;
             for(i=0;i<4;i++) tmp_exit[i] = -1;}

exitList : exitList exit 

exit : tok_DIRN tok_IDENT 
           {tmp_exit[$1] = find($2);}

%%


void writeMap(FILE *fout) {
  int i, j;
  fprintf(fout,"var map = new Array(%d);\n",nLoc);
  for(i=0;i<nLoc;i++) {
    fprintf(fout,"map[%d] = new Array(",i);
    for(j=0;j<4;j++) {
      fprintf(fout,"%d",locList[i].exits[j]);
      if(j<3) fprintf(fout,", ");
    }
    fprintf(fout,");\n");
  }
}

void writeNamesDescr(FILE *fout) {
  int i;
  /*The names*/

  fprintf(fout,"var locName = new Array(");
  for(i=0;i<nLoc;i++) {
    fprintf(fout,"\"%s\"",locList[i].name);
    if(i<nLoc-1) fprintf(fout,",\n");
  }
  fprintf(fout,");\n");

  /*The desriptions*/

  fprintf(fout,"var locDescr = new Array(");
  for(i=0;i<nLoc;i++) {
    fprintf(fout,"\"%s\"",locList[i].descr);
    if(i<nLoc-1) fprintf(fout,",\n");
  }
  fprintf(fout,");\n");
}


void writeState(FILE *fout) {
  int i;

  fprintf(fout,"startLoc = %d;\n",startLoc);
  fprintf(fout,"nMove = 0;\n");
  fprintf(fout,"nVisit = 1;\n");
  fprintf(fout,"visited = new Array(1,");
  for(i=1;i<nLoc-1;i++)
    fprintf(fout,"0,");
  fprintf(fout,"0);\n");
}

void emitCode(FILE *fout) {
  writeMap(fout);
  writeNamesDescr(fout);
  writeState(fout);
}



int yyerror(char *errMessage) {
   printf("Trouble: %s\n",errMessage);
}

main() {
  FILE *fout;
  yyparse();

  fout = fopen("change.js","w");  
  emitCode(fout);
}   
